from io import BytesIO
from itertools import product
import pytest

from gargantools.utils.utils import get_fileContent
from gargantools.utils.validation_utils import contexts_check_fileContent, terms_check_fileContent
from tests.conftest import id_files


@pytest.mark.parametrize("test_file_copy", product(["contexts", "terms"], ["correct.csv"]), indirect=True, ids=lambda param : id_files(param))
def test_check_fileContent(test_file_copy):
    test_file, cat_type = test_file_copy
    with open(test_file, "r") as f:
        f_data = BytesIO(f.read().encode("utf-8"))
        if cat_type == "contexts":
            assert contexts_check_fileContent(get_fileContent(f_data, '\t')) == (True, None)
        elif cat_type == "terms":
            assert terms_check_fileContent(get_fileContent(f_data, '\t')) == (True, None)
